# Get an app tunnel

`GET /apis/cra.diagrid.io/v1beta1/projects/{ProjectId}/apptunnels/{ProjectSubresourceId}`

Get the details of an app tunnel.

## Request

### Path parameters

| Name | Type | Required | Description |
| --- | --- | --- | --- |
| `ProjectId` | string | Yes | Unique identifier of the project. |
| `ProjectSubresourceId` | string | Yes | Unique identifier of the project subresource. |

## Responses

### 200 — The requested app tunnel.

`application/json`

- `apiVersion` (string)
- `kind` (string)
- `metadata` (object)
  - `name` (string)
  - `uid` (string)
  - `resourceVersion` (integer)
  - `createdAt` (string)
  - `updatedAt` (string)
  - `deletedAt` (string)
  - `labels` (object<string, string>)
  - `annotations` (object)
- `spec` (object) — AppTunnelSpec represents the spec for an AppTunnel.
  - `projectId` (string) — Required. Read-only. Immutable. ProjectID is server-derived from the request path.
  - `tunnelConnectionGeneration` (integer (int64))
  - `appHealthCheck` (object)
    - `path` (string) — used for HTTP e.g. /health.
    - `probe` (object)
      - `enabled` (boolean)
      - `intervalInSec` (integer (int32))
      - `timeoutInMs` (integer (int32))
      - `failureThreshold` (integer (int32))
  - `provider` (string) — Immutable.
  - `createdBy` (string) — Required. Read-only. Immutable. CreatedBy is server-derived from the caller identity.
- `status` (object) — AppTunnelStatus represents the status of an AppTunnel.
  - `status` (string)
  - `messages` (object[])
    - `message` (string)
  - `processedSpecVersion` (integer (int64))
  - `tunnelConnectionGeneration` (integer (int64))
  - `tunnelConnection` (object) — AppTunnelConnection represents a tunnel connection.
    - `endpoint` (string) — Endpoint refers to the address that the client will reach to in order to connect to the tunnel, aka Upstream.
    - `proxy_endpoint` (string) — ProxyEndpoint is the address that the sidecar will forward the requests to from its side of the tunnel.
    - `proxy_tls` (boolean) — ProxyTLS controls the protocol to be used in Proxy side of the connection.
    - `credentials` (object) — AppTunnelCredentials represents credentials for a tunnel connection.
      - `id` (string)
      - `expiresAt` (string)
      - `token` (string)
      - `spiffeId` (string)
    - `extra_headers` (object<string, string>)
  - `cliCreds` (string)

`application/vnd.api+json`

JSONAPI.org specification app tunnel response wrapper for UI.

- `data` (object) — Required.
  - `type` (string) — Type of the resource object.
  - `id` (string) — Unique identifier of the resource object.
  - `attributes` (object)
    - `apiVersion` (string)
    - `kind` (string)
    - `metadata` (object)
      - `name` (string)
      - `uid` (string)
      - `resourceVersion` (integer)
      - `createdAt` (string)
      - `updatedAt` (string)
      - `deletedAt` (string)
      - `labels` (object<string, string>)
      - `annotations` (object)
    - `spec` (object) — AppTunnelSpec represents the spec for an AppTunnel.
      - `projectId` (string) — Required. Read-only. Immutable. ProjectID is server-derived from the request path.
      - `tunnelConnectionGeneration` (integer (int64))
      - `appHealthCheck` (object)
        - `path` (string) — used for HTTP e.g. /health.
        - `probe` (object)
          - `enabled` (boolean)
          - `intervalInSec` (integer (int32))
          - `timeoutInMs` (integer (int32))
          - `failureThreshold` (integer (int32))
      - `provider` (string) — Immutable.
      - `createdBy` (string) — Required. Read-only. Immutable. CreatedBy is server-derived from the caller identity.
    - `status` (object) — AppTunnelStatus represents the status of an AppTunnel.
      - `status` (string)
      - `messages` (object[])
        - `message` (string)
      - `processedSpecVersion` (integer (int64))
      - `tunnelConnectionGeneration` (integer (int64))
      - `tunnelConnection` (object) — AppTunnelConnection represents a tunnel connection.
        - `endpoint` (string) — Endpoint refers to the address that the client will reach to in order to connect to the tunnel, aka Upstream.
        - `proxy_endpoint` (string) — ProxyEndpoint is the address that the sidecar will forward the requests to from its side of the tunnel.
        - `proxy_tls` (boolean) — ProxyTLS controls the protocol to be used in Proxy side of the connection.
        - `credentials` (object) — AppTunnelCredentials represents credentials for a tunnel connection.
          - `id` (string)
          - `expiresAt` (string)
          - `token` (string)
          - `spiffeId` (string)
        - `extra_headers` (object<string, string>)
      - `cliCreds` (string)
  - `relationships` (object<string, object>) — Members of the relationships object represent references from the resource object in which it's defined to other resource objects.
    - Any of:
      - **option 1**
      - **option 2**
      - **option 3**
  - `links` (object<string, object>) — Link members related to the primary data.
    - One of:
      - **string (uri-reference)** — A string containing the link's URL.
      - **object**
        - `href` (string (uri-reference)) — Required. A string containing the link's URL.
        - `meta` (object) — Non-standard meta-information that can not be represented as an attribute or relationship.
  - `meta` (object) — Non-standard meta-information that can not be represented as an attribute or relationship.
- `links` (object<string, object>) — Link members related to the primary data.
  - One of:
    - **string (uri-reference)** — A string containing the link's URL.
    - **object**
      - `href` (string (uri-reference)) — Required. A string containing the link's URL.
      - `meta` (object) — Non-standard meta-information that can not be represented as an attribute or relationship.

### 404 — The app tunnel was not found.

`application/json`

In the case of an error, a standard format error response body will be returned and the HTTP status code will be set to an error status. The response contains an object with a single error object.

- `code` (string) — Required. This is the same as the HTTP status of the response.
- `message` (string) — Required. A short description of the error.
- `status` (object) — Required. A status code that indicates the error type.
- `details` (object) — Additional details about the errors.
  - `@type` (string) — The type of error.
  - `reason` (string) — A reason for the error.
  - `domain` (string) — The domain in which the error occurred.
  - `metadata` (object) — Additional metadata about the error.

`application/vnd.api+json`

JSONAPI.org specification error response wrapper for UI.

- `error` (object) — In the case of an error, a standard format error response body will be returned and the HTTP status code will be set to an error status. The response contains an object with a single error object.
  - `code` (string) — Required. This is the same as the HTTP status of the response.
  - `message` (string) — Required. A short description of the error.
  - `status` (object) — Required. A status code that indicates the error type.
  - `details` (object) — Additional details about the errors.
    - `@type` (string) — The type of error.
    - `reason` (string) — A reason for the error.
    - `domain` (string) — The domain in which the error occurred.
    - `metadata` (object) — Additional metadata about the error.
- `meta` (object<string, object>) — Link members related to the primary data.
  - One of:
    - **string (uri-reference)** — A string containing the link's URL.
    - **object**
      - `href` (string (uri-reference)) — Required. A string containing the link's URL.
      - `meta` (object) — Non-standard meta-information that can not be represented as an attribute or relationship.
- `links` (object) — Non-standard meta-information that can not be represented as an attribute or relationship.

### default — Unexpected error.

`application/json`

In the case of an error, a standard format error response body will be returned and the HTTP status code will be set to an error status. The response contains an object with a single error object.

- `code` (string) — Required. This is the same as the HTTP status of the response.
- `message` (string) — Required. A short description of the error.
- `status` (object) — Required. A status code that indicates the error type.
- `details` (object) — Additional details about the errors.
  - `@type` (string) — The type of error.
  - `reason` (string) — A reason for the error.
  - `domain` (string) — The domain in which the error occurred.
  - `metadata` (object) — Additional metadata about the error.

`application/vnd.api+json`

JSONAPI.org specification error response wrapper for UI.

- `error` (object) — In the case of an error, a standard format error response body will be returned and the HTTP status code will be set to an error status. The response contains an object with a single error object.
  - `code` (string) — Required. This is the same as the HTTP status of the response.
  - `message` (string) — Required. A short description of the error.
  - `status` (object) — Required. A status code that indicates the error type.
  - `details` (object) — Additional details about the errors.
    - `@type` (string) — The type of error.
    - `reason` (string) — A reason for the error.
    - `domain` (string) — The domain in which the error occurred.
    - `metadata` (object) — Additional metadata about the error.
- `meta` (object<string, object>) — Link members related to the primary data.
  - One of:
    - **string (uri-reference)** — A string containing the link's URL.
    - **object**
      - `href` (string (uri-reference)) — Required. A string containing the link's URL.
      - `meta` (object) — Non-standard meta-information that can not be represented as an attribute or relationship.
- `links` (object) — Non-standard meta-information that can not be represented as an attribute or relationship.
